"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.migrateContract = exports.upgradeContract = exports.authorizeUpgrade = void 0;
// Contract upgrade
var authorizeUpgrade = function (address, vaa) {
    if (!address)
        throw "Need bridge address.";
    return {
        function: address + "::contract_upgrade::submit_vaa_entry",
        type_arguments: [],
        arguments: [vaa],
    };
};
exports.authorizeUpgrade = authorizeUpgrade;
var upgradeContract = function (address, metadataSerialized, code) {
    if (!address)
        throw "Need bridge address.";
    return {
        function: address + "::contract_upgrade::upgrade",
        type_arguments: [],
        arguments: [metadataSerialized, code],
    };
};
exports.upgradeContract = upgradeContract;
var migrateContract = function (address) {
    if (!address)
        throw "Need bridge address.";
    return {
        function: address + "::contract_upgrade::migrate",
        type_arguments: [],
        arguments: [],
    };
};
exports.migrateContract = migrateContract;
