"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initWormhole = exports.upgradeGuardianSet = void 0;
// Guardian set upgrade
var upgradeGuardianSet = function (coreBridgeAddress, vaa) {
    if (!coreBridgeAddress)
        throw "Need core bridge address.";
    return {
        function: coreBridgeAddress + "::guardian_set_upgrade::submit_vaa_entry",
        type_arguments: [],
        arguments: [vaa],
    };
};
exports.upgradeGuardianSet = upgradeGuardianSet;
// Init WH
var initWormhole = function (coreBridgeAddress, chainId, governanceChainId, governanceContract, initialGuardian) {
    if (!coreBridgeAddress)
        throw "Need core bridge address.";
    return {
        function: coreBridgeAddress + "::wormhole::init",
        type_arguments: [],
        arguments: [chainId, governanceChainId, governanceContract, initialGuardian],
    };
};
exports.initWormhole = initWormhole;
