import { ChainId } from "../utils";
import { AptosAccount, AptosClient, Types } from "aptos";
export declare const signAndSubmitTransaction: (client: AptosClient, sender: AptosAccount, payload: Types.EntryFunctionPayload, opts?: Partial<{
    sender: string;
    sequence_number: string;
    max_gas_amount: string;
    gas_unit_price: string;
    expiration_timestamp_secs: string;
    payload: Types.TransactionPayload;
    signature: ({
        type: string;
    } & Types.Ed25519Signature) | ({
        type: string;
    } & {
        sender: ({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & Types.MultiEd25519Signature);
        secondary_signer_addresses: string[];
        secondary_signers: (({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & Types.MultiEd25519Signature))[];
    }) | ({
        type: string;
    } & Types.MultiEd25519Signature);
}> | undefined) => Promise<Types.PendingTransaction>;
/**
 * Create a transaction using the given payload and commit it on-chain.
 *
 * This functionality can be replicated by calling
 * `signAndSubmitTransaction(...).then(tx => client.waitForTransactionWithResult(tx.hash))`.
 * @param client
 * @param sender
 * @param payload
 * @returns Transaction info
 */
export declare const waitForSignAndSubmitTransaction: (client: AptosClient, sender: AptosAccount, payload: Types.EntryFunctionPayload) => Promise<Types.UserTransaction>;
export declare const getAssetFullyQualifiedType: (tokenBridgeAddress: string, originChain: ChainId, originAddress: string) => string | null;
export declare const getForeignAssetAddress: (tokenBridgeAddress: string, originChain: ChainId, originAddress: string) => string | null;
